/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.service.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;

/**
* @website https://el-admin.vip
* @description /
* @author sunmz
* @date 2021-09-15
**/
@Data
public class DmServicePjDto implements Serializable {

    private Integer id;

    /** 评价用户 */
    private String userName;

    /** 用户工号 */
    private String userCode;

    private String userNumber;

    /** 综合评分 */
    private String totalPoint;

    /** 评价时间 */
    private Timestamp pjTime;

    /** 味道 */
    private Integer wdPoint;

    /** 品种 */
    private Integer pzPoint;

    /** 分量 */
    private Integer flPoint;

    /** 服务态度 */
    private Integer fwtdPoint;

    /** 环境卫生 */
    private Integer hjwsPoint;

    /** 综合服务 */
    private Integer zhfwPoint;

    /** 持续改进 */
    private Integer cxgjPoint;

    /** 意见建议 */
    private String remark;

    private String enabled;
}